commit f7524078f9a1ef6ddcedb147fb464ec3c4af4391
Author: freddy77 <freddy77>
Date:   Mon Oct 6 13:45:15 2008 +0000

    fixed string truncation with charset with shift state

diff --git a/ChangeLog b/ChangeLog
index ae55fa5..437ee92 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Mon Oct 06 15:43:03 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/.cvsignore src/odbc/unittests/Makefile.am:
+	* src/tds/iconv.c src/odbc/unittests/utf8_2.c(added):
+	- fixed string truncation with charset with shift state
+
 Thu Oct 01 10:06:13 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/replacements/basename.c src/replacements/gettimeofday.c:
 	- remove wrong comments
@@ -680,4 +685,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2616 2008/10/02 08:08:00 freddy77 Exp $
+$Id: ChangeLog,v 1.2617 2008/10/06 13:45:15 freddy77 Exp $
diff --git a/src/odbc/unittests/.cvsignore b/src/odbc/unittests/.cvsignore
index af134ad..fb2e37e 100644
--- a/src/odbc/unittests/.cvsignore
+++ b/src/odbc/unittests/.cvsignore
@@ -72,4 +72,5 @@ test64
 wchar
 transaction2
 utf8
+utf8_2
 
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index 9afecee..f04a6ab 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.77 2008/08/16 14:48:57 freddy77 Exp $
+# $Id: Makefile.am,v 1.78 2008/10/06 13:45:15 freddy77 Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -22,7 +22,7 @@ TESTS		=	\
 			cursor3$(EXEEXT) cursor4$(EXEEXT) cursor5$(EXEEXT) \
 			attributes$(EXEEXT) hidden$(EXEEXT) blob1$(EXEEXT) \
 			cancel$(EXEEXT) wchar$(EXEEXT) rowset$(EXEEXT) transaction2$(EXEEXT) \
-			cursor6$(EXEEXT) cursor7$(EXEEXT) utf8$(EXEEXT)
+			cursor6$(EXEEXT) cursor7$(EXEEXT) utf8$(EXEEXT) utf8_2$(EXEEXT)
 
 check_PROGRAMS	=	$(TESTS)
 
@@ -88,6 +88,7 @@ transaction2_SOURCES = transaction2.c common.c common.h
 cursor6_SOURCES	= cursor6.c common.c common.h
 cursor7_SOURCES	= cursor7.c common.c common.h
 utf8_SOURCES	= utf8.c common.c common.h
+utf8_2_SOURCES	= utf8_2.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC) -DFREETDS_SRCDIR=\"$(srcdir)\"
 if MINGW32
diff --git a/src/odbc/unittests/utf8_2.c b/src/odbc/unittests/utf8_2.c
new file mode 100755
index 0000000..e2c3290
--- /dev/null
+++ b/src/odbc/unittests/utf8_2.c
@@ -0,0 +1,110 @@
+#include "common.h"
+
+/* test conversion of Hebrew characters (which have shift sequences) */
+static char software_version[] = "$Id: utf8_2.c,v 1.1 2008/10/06 13:45:15 freddy77 Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+static void init_connect(void);
+
+static void
+init_connect(void)
+{
+	if (SQLAllocEnv(&Environment) != SQL_SUCCESS) {
+		printf("Unable to allocate env\n");
+		exit(1);
+	}
+	SQLSetEnvAttr(Environment, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) (SQL_OV_ODBC3), SQL_IS_UINTEGER);
+	if (SQLAllocConnect(Environment, &Connection) != SQL_SUCCESS) {
+		printf("Unable to allocate connection\n");
+		SQLFreeEnv(Environment);
+		exit(1);
+	}
+}
+
+static const char * const strings[] = {
+	"\xd7\x9e\xd7\x99\xd7\x93\xd7\xa2",
+	"info",
+	"\xd7\x98\xd7\xa7\xd7\xa1\xd7\x98",
+	"\xd7\x90\xd7\x91\xd7\x9b",
+	NULL
+};
+
+/* same strings in hex */
+static const char * const strings_hex[] = {
+	"0xde05d905d305e205",
+	"0x69006e0066006f00",
+	"0xd805e705e105d805",
+	"0xd005d105db05",
+	NULL
+};
+
+int
+main(int argc, char *argv[])
+{
+	char tmp[128];
+	char out[32];
+	SQLLEN n_len;
+	int res;
+	SQLSMALLINT len;
+	const char * const*p;
+	int n;
+
+	if (read_login_info())
+		exit(1);
+
+	/* connect string using DSN */
+	init_connect();
+	sprintf(tmp, "DSN=%s;UID=%s;PWD=%s;DATABASE=%s;ClientCharset=UTF-8;", SERVER, USER, PASSWORD, DATABASE);
+	res = SQLDriverConnect(Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT);
+	if (!SQL_SUCCEEDED(res)) {
+		fprintf(stderr, "Unable to open data source (ret=%d)\n", res);
+		CheckReturn();
+		return 1;
+	}
+	if (!driver_is_freetds()) {
+		Disconnect();
+		printf("Driver is not FreeTDS, exiting\n");
+		return 0;
+	}
+
+	memset(tmp, 0, sizeof(tmp));
+	SQLGetInfo(Connection, SQL_DBMS_VER, tmp, sizeof(tmp), &len);
+	if (!db_is_microsoft() || (strncmp(tmp, "08.00.", 6) != 0 && strncmp(tmp, "09.00.", 6) != 0)) {
+		Disconnect();
+		printf("Test for MSSQL only\n");
+		return 0;
+	}
+
+	if (SQLAllocStmt(Connection, &Statement) != SQL_SUCCESS) {
+		printf("Unable to allocate statement\n");
+		CheckReturn();
+	}
+
+	/* create test table */
+	Command(Statement, "CREATE TABLE #tmpHebrew (i INT, v VARCHAR(10) COLLATE Hebrew_CI_AI)");
+
+	/* insert with INSERT statements */
+	for (n = 0, p = strings_hex; p[n]; ++n) {
+		sprintf(tmp, "INSERT INTO #tmpHebrew VALUES(%d, CAST(%s AS NVARCHAR(10)))", n+1, p[n]);
+		Command(Statement, tmp);
+	}
+
+	/* test conversions in libTDS */
+	Command(Statement, "SELECT v FROM #tmpHebrew");
+
+	/* insert with SQLPrepare/SQLBindParameter/SQLExecute */
+	CHK(SQLBindCol, (Statement, 1, SQL_C_CHAR, out, sizeof(out), &n_len));
+	for (n = 0, p = strings; p[n]; ++n) {
+		CHK(SQLFetch, (Statement));
+		if (n_len != strlen(p[n]) || strcmp(p[n], out) != 0) {
+			fprintf(stderr, "Wrong row %s\n", out);
+			Disconnect();
+			return 1;
+		}
+	}
+
+	Disconnect();
+	printf("Done.\n");
+	return 0;
+}
+
diff --git a/src/tds/iconv.c b/src/tds/iconv.c
index 6f0c4ae..014fd57 100644
--- a/src/tds/iconv.c
+++ b/src/tds/iconv.c
@@ -49,7 +49,7 @@
 /* define this for now; remove when done testing */
 #define HAVE_ICONV_ALWAYS 1
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.133 2008/08/13 04:09:32 jklowden Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.134 2008/10/06 13:45:15 freddy77 Exp $");
 
 #define CHARSIZE(charset) ( ((charset)->min_bytes_per_char == (charset)->max_bytes_per_char )? \
 				(charset)->min_bytes_per_char : 0 )
@@ -691,7 +691,7 @@ tds_iconv(TDSSOCKET * tds, const TDSICONV * conv, TDS_ICONV_DIRECTION io,
 				errno = 0;
 				irreversible = tds_sys_iconv(cd2, (ICONV_CONST char **) &pb, &l, outbuf, outbytesleft);
 				if (irreversible != (size_t) - 1) {
-					if (*inbytesleft)
+					if (inbytesleft && *inbytesleft)
 						break;
 					goto end_loop;
 				}
@@ -721,7 +721,7 @@ tds_iconv(TDSSOCKET * tds, const TDSICONV * conv, TDS_ICONV_DIRECTION io,
 			errno = temp_errno;
 			irreversible = temp_irreversible;
 			break;
-		} else if (io == to_client && conv->flags & TDS_ENCODING_SWAPBYTE) {
+		} else if (io == to_client && conv->flags & TDS_ENCODING_SWAPBYTE && inbuf) {
 			/* swap bytes if necessary */
 #if ENABLE_EXTRA_CHECKS
 			char tmp[8];
@@ -745,13 +745,20 @@ tds_iconv(TDSSOCKET * tds, const TDSICONV * conv, TDS_ICONV_DIRECTION io,
 		} else {
 			irreversible = tds_sys_iconv(cd, (ICONV_CONST char **) inbuf, inbytesleft, outbuf, outbytesleft);
 		}
-		if (irreversible != (size_t) - 1)
+		/* iconv success, return */
+		if (irreversible != (size_t) - 1) {
+			if (inbuf) {
+				inbuf = NULL;
+				inbytesleft = 0;
+				continue;
+			}
 			break;
+		}
 
 		if (errno == EILSEQ)
 			eilseq_raised = 1;
 
-		if (errno != EILSEQ || io != to_client)
+		if (errno != EILSEQ || io != to_client || !inbuf)
 			break;
 		/* 
 		 * Invalid input sequence encountered reading from server. 

